package net.tk_factory.sample.apache.poi.row;

import java.io.FileOutputStream;
import java.io.IOException;
import net.tk_factory.sample.AbstractSample;
import org.apache.log4j.Logger;
import org.apache.poi.hssf.usermodel.HSSFRow;
import org.apache.poi.hssf.usermodel.HSSFSheet;
import org.apache.poi.hssf.usermodel.HSSFWorkbook;

/**
 * Apache POI-HSSFѤץץǤ<br/>
 * <br/>
 * <b></b>
 * <ol type="1">
 * <li>HSSFSheet饹removeRow᥽åɤѤơԤɲäޤ</li>
 * </ol>
 * @author Takafumi Kondo (TK Factory)
 * @see org.apache.poi.hssf.usermodel.HSSFSheet#removeRow(org.apache.poi.hssf.usermodel.HSSFRow)
 */
public class SampleRemoveRow extends AbstractSample
{
    /** 饹̾ */
    private static final String CLASS_NAME =
        SampleRemoveRow.class.getSimpleName();

    /**  */
    private static final Logger LOGGER =
        Logger.getLogger(SampleRemoveRow.class.getName());

    /** ϥե̾ */
    private static final String OUT_FILE_NAME =
        SAMPLE_FILE_DIRECTORY + CLASS_NAME + "Out.xls";

    /**
     * SampleRemoveRow֥Ȥۤȡ
     * UnsupportedOperationExceptionޤ<br/>
     */
    protected SampleRemoveRow()
    {
        throw new UnsupportedOperationException();
    }

    /**
     * main᥽åɤǤ<br/>
     *
     * @param args 
     */
    public static void main(String[] args)
    {
        FileOutputStream out = null;

        try
        {
            //Ǥ˽ϥե뤬¸ߤƤϺ
            deleteExistsFile(OUT_FILE_NAME);

            //֥å
            HSSFWorkbook workbook = new HSSFWorkbook();

            //Ȥɲä
            HSSFSheet sheet = workbook.createSheet();
            LOGGER.debug(sheet.toString());

            //Ԥɲäʣܡ
            HSSFRow row1 = sheet.createRow(0);
            LOGGER.debug(row1.toString());

            //Ԥɲäʣܡ
            HSSFRow row2 = sheet.createRow(1);
            LOGGER.debug(row2.toString());

            //Ԥʣܡ
            sheet.removeRow(row1);

            //ե¸
            out = new FileOutputStream(OUT_FILE_NAME);
            workbook.write(out);
        }
        catch (IOException ioex)
        {
            LOGGER.error(getStackTrace(ioex));
        }
        finally
        {
            try
            {
                if (out != null)
                {
                    out.close();
                }
            }
            catch (IOException ioex)
            {
                LOGGER.error(getStackTrace(ioex));
            }
        }
    }
}
